/**
 * @module flitter-orm/src/proxy/model/LimitProxy
 */

const ModelProxy = require('./ModelProxy')

/**
 * Proxy that limits the number of records in the reference's result set.
 * @extends module:flitter-orm/src/proxy/model/ModelProxy~ModelProxy
 */
class LimitProxy extends ModelProxy {
    /**
     * Instantiate the proxy
     * @param {module:flitter-orm/src/model/Model~Model|module:flitter-orm/src/proxy/model/ModelProxy~ModelProxy} model - proxy ref
     * @param {number} limit - the number to limit to
     * @param {module:flitter-orm/src/model/CursorBuilder~CursorBuilder} [builder] - optionally, the cursor builder to use
     */
    constructor(model, limit, builder = undefined) {
        super(model, builder)
        this._limit = limit
        this.builder.limit(limit)
    }
}

module.exports = exports = LimitProxy
